<!DOCTYPE html>
<html>

<head>
  <title> Task 25.30 ... Tạo đơn hàng - xem chi tiết </title>
  <meta charset='utf-8'>
  <meta name='viewport' content='width=device-width, initial-scale=1'>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
  <div class="container jumbotron">
    <div class="col-12">
      <div class="text-center mb-5">
        <h1> Create Order </h1>
      </div>
      <div class="form-group row">
        <label for="" class="col-sm-2 col-form-label">Cỡ Combo</label>
        <div class="col-sm-4">
          <select id="select-combo" class="form-control">
            <option value="0"> Chọn cỡ Combo (Combo size)</option>
            <option value="S"> Nhỏ</option>
            <option value="M"> Vừa</option>
            <option value="L"> Lớn</option>
          </select>
        </div>
        <label for="" class="col-sm-2 col-form-label">Đồ uống</label>
        <div class="col-sm-4">
          <select class="form-control" id="select-drink">
            <option value="0">Chọn đồ uống</option>
          </select>
        </div>
      </div>
      <div class="form-group row">
        <label class="col-sm-2 col-form-label">Mã voucher</label>
        <div class="col-sm-4">
          <input id="inp-voucher" type="text" class="form-control" placeholder="Voucher ID (mã voucher)">
        </div>
        <label class="col-sm-2 col-form-label">Loại pizza</label>
        <div class="col-sm-4">
          <select id="select-pizza" class="form-control"> <!-- select chưa có id, các option chưa có value-->
            <option value="0"> Chọn loại pizza </option>
            <option value="Seafood"> Hải sản</option>
            <option value="Hawaii"> Ha wai </option>
            <option value="Bacon"> Thịt hun khói </option>
          </select>
        </div>
      </div>
      <div class="form-group row">
        <label class="col-sm-2 col-form-label" for="">Họ và tên</label>
        <div class="col-sm-4">
          <input id="inp-name" type="text" class="form-control" placeholder="Họ và tên">
        </div>
        <label for="" class="col-sm-2 col-form-label">Email</label>
        <div class="col-sm-4">
          <input id="inp-email" type="email" class="form-control" placeholder="Email">
        </div>
      </div>
      <div class="form-group row">
        <label class="col-sm-2 col-form-label">Số điện thoại</label>
        <div class="col-sm-4">
          <input id="inp-phone" type="text" class="form-control" placeholder="Số điện thoại">
        </div>
        <label class="col-sm-2 col-form-label">Địa chỉ</label>
        <div class="col-sm-4">
          <input id="inp-address" type="text" class="form-control" placeholder="Địa chỉ">
        </div>
      </div>
      <div class="form-group">
        <label>Lời nhắn</label>
        <textarea id="inp-message" class="form-control h-75" placeholder="Lời nhắn"></textarea>
      </div>
      <div class="form-group">
        <button onclick="onBtnCreatOderClick()" class="btn btn-primary">Create Order</button>
        <button onclick="onBtnShowOrderData()" id="btn-show-order-data" class="btn btn-secondary">Show Order Data in New
          Form</button>
      </div>
    </div>
  </div>
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gREQUEST_CREATE_SUCCESS = 201; // status 201 - tạo thành công
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */


    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
      // load dữ liệu vào select car
      loadDataDrinkList();
    }
    // hàm create order
    function onBtnCreatOderClick() {
      console.log("Create Order được ấn")
      var vCreatOrder = {
        kichCo: "",
        duongKinh: "",
        suon: "",
        salad: "",
        loaiPizza: "",
        idVourcher: "",
        idLoaiNuocUong: "",
        soLuongNuoc: "",
        hoTen: "",
        thanhTien: "",
        email: "",
        soDienThoai: "",
        diaChi: "",
        loiNhan: ""

      }
      // B1: Thu thập dữ liệu 
      readDataInp(vCreatOrder)
      // Kiểm tra
      var isCheck = vadidateDataInp(vCreatOrder);
      if (isCheck) {
        var vXmlHttpCreateOrder = new XMLHttpRequest();
        // Call APii
        callApiCreateOrder(vCreatOrder, vXmlHttpCreateOrder);

        vXmlHttpCreateOrder.onreadystatechange = function () {
          if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_CREATE_SUCCESS) { // status 201 tao thanh cong
            // hiển thị 
            handlerCreateData(vXmlHttpCreateOrder)
          }
        }
      }
    }
    // hàm show order data
    function onBtnShowOrderData() {
      var vElementButtonShowOrder = document.getElementById("btn-show-order-data");
      var vGetOderCode = vElementButtonShowOrder.dataset.ordercode
      console.log("Order code là: " + vGetOderCode);
      // chuyển sang trang orderDetail
      window.location.href = "orderDetail.html" + "?ordercode=" + vGetOderCode

    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm thực hiện call api để load dữ liệu vào drink list
    function loadDataDrinkList() {
      var vXhttp = new XMLHttpRequest();
      vXhttp.open("GET", "http://203.171.20.210:8080/devcamp-pizza365/drinks", true);
      vXhttp.send();
      vXhttp.onreadystatechange = function () {
        if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
          console.log(vXhttp.responseText); // ghi response text ra console.log
          handleLoadDataToSelectDrink(vXhttp);
        }
      };
    }

    // handle data load to select drink
    function handleLoadDataToSelectDrink(paramXhttp) {
      var vArrayDrinkList = JSON.parse(paramXhttp.responseText);
      console.log("array drink list = " + vArrayDrinkList.length);
      //load data to drink select
      var vElementSelectDrink = document.getElementById("select-drink");
      for (var bIterator = 0; bIterator < vArrayDrinkList.length; bIterator++) {
        var vDrinkOptionElement = document.createElement("option");
        vDrinkOptionElement.value = vArrayDrinkList[bIterator].maNuocUong;
        vDrinkOptionElement.text = vArrayDrinkList[bIterator].tenNuocUong;
        vElementSelectDrink.appendChild(vDrinkOptionElement);
      }
    }
    function readDataInp(paramOrder) {
      var vCombo = document.getElementById("select-combo");
      var vVoucher = document.getElementById("inp-voucher");
      var vDrink = document.getElementById("select-drink");
      var vTypePizza = document.getElementById("select-pizza");
      var vName = document.getElementById("inp-name");
      var vPhone = document.getElementById("inp-phone");
      var vEmail = document.getElementById("inp-email");
      var vAddress = document.getElementById("inp-address");
      var vMessage = document.getElementById("inp-message");

      paramOrder.kichCo = vCombo.options[vCombo.selectedIndex].value;
      paramOrder.idLoaiNuocUong = vDrink.options[vDrink.selectedIndex].value;
      paramOrder.loaiPizza = vTypePizza.options[vTypePizza.selectedIndex].value;
      paramOrder.idVourcher = vVoucher.value.trim();
      paramOrder.hoTen = vName.value.trim();
      paramOrder.soDienThoai = vPhone.value.trim();
      paramOrder.email = vEmail.value.trim();
      paramOrder.diaChi = vAddress.value.trim();
      paramOrder.loiNhan = vMessage.value.trim();

      if (paramOrder.kichCo == "S") {
        paramOrder.duongKinh = 20;
        paramOrder.suon = 2;
        paramOrder.salad = 200;
        paramOrder.soLuongNuoc = 2;
        paramOrder.thanhTien = 150.000;

      } else if (paramOrder.kichCo == "M") {
        paramOrder.duongKinh = 25;
        paramOrder.suon = 4;
        paramOrder.salad = 300;
        paramOrder.soLuongNuoc = 3;
        paramOrder.thanhTien = 200.000;

      } else if (paramOrder.kichCo == "L") {
        paramOrder.duongKinh = 30;
        paramOrder.suon = 8;
        paramOrder.salad = 500;
        paramOrder.soLuongNuoc = 4;
        paramOrder.thanhTien = 250.000;

      }
    }
    function vadidateDataInp(paramOrder) {
      if (paramOrder.kichCo == "0") {
        alert("Hãy chọn Cỡ Combo")
        return false
      }
      if (paramOrder.idLoaiNuocUong == "0") {
        alert("Hãy chọn Loại đồ uống")
        return false
      }
      if (paramOrder.loaiPizza == "0") {
        alert("Hãy chọn Loại Pizza")
        return false
      }
      if (paramOrder.hoTen == "") {
        alert("Hãy nhập Họ và tên")
        return false
      }
      if (paramOrder.soDienThoai == "") {
        alert("Hãy nhập số điện thoại")
        return false
      }
      if (isNaN(paramOrder.soDienThoai)) {
        alert("Số điện thoại bạn nhập không phải là số")
        return false
      }
      if (paramOrder.email == "") {
        alert("Hãy nhập Email")
        return false
      }
      if (paramOrder.diaChi == "") {
        alert("Hãy nhập Địa chỉ")
        return false
      }
      return true
    }
    function callApiCreateOrder(paramOrder, paramXmlHttp) {
      paramXmlHttp.open("POST", gBASE_URL, true);
      paramXmlHttp.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
      paramXmlHttp.send(JSON.stringify(paramOrder));
    }
    function handlerCreateData(paramXmlHttp) {
      var vCreatedOrder = paramXmlHttp.responseText;
      console.log(vCreatedOrder)

      var vOderOjb = JSON.parse(paramXmlHttp.responseText);
      var vOderCode = vOderOjb.orderCode;

      var vElementButtonShowOrder = document.getElementById("btn-show-order-data");
      vElementButtonShowOrder.setAttribute("data-ordercode", vOderCode)

    }
  </script>


</body>

</html>